<?php
require_once("pgsql.php");

//========================================================================
// Class Name		:	clsPipeDB
//------------------------------------------------------------------------
// Function			:	DataBaseΥѥץ饹(PostgreSQL)
// Note				:	PostgreSQLѤδؿڤӥơȥȸƤӽФ
//						ޤȤ᤿饹⥸塼
//========================================================================
class clsPipeDB {
	var $PipeName = "PostgreSQL";

	function DB_Connect() {
		$db	= new clsPGSQL(DEF_DB_HOST, DEF_DB_USER, DEF_DB_PASS, DEF_DB_NAME);
		return $db;
	}

	function DB_Fields_Trans($row) {
		$ret_row	= array();
		if ( is_array($row) ) {
			foreach( $row as $key=>$val ) {
				$key_buff = strtolower($key);
				$ret_row[$key_buff] = $val;
			}
		}
		return $ret_row;
	}

	function DB_fetch_assoc($result) {
		$row = array();
		$row = @pg_fetch_assoc($result);
		$row = $this->DecodeEntities($row);
		$ret_row = $this->DB_Fields_Trans($row);
		return $ret_row;
	}

	function DB_fetch_array($result) {
		$row = array();
		$row = @pg_fetch_array($result);
		$row = $this->DecodeEntities($row);
		$ret_row = $this->DB_Fields_Trans($row);
		return $ret_row;
	}

	function DB_fetch_row($result) {
		$row = array();
		$row = @pg_fetch_row($result);
		$row = $this->DecodeEntities($row);
		return $row;
	}

	function DB_num_rows($result) {
		$cnt = 0;
		$cnt = @pg_num_rows($result);
		return $cnt;
	}

	function DB_insert_id($db, $topic_table, $Fields) {
		$SQL_query = "";
		$Where = "";

		$SQL_query = "SELECT i_MainID FROM ".$topic_table;
		$SQL_query .= " WHERE ";
		
		if ( is_array($Fields) ) {
			foreach( $Fields as $key=>$val ) {
				if ( $val != "" ) {
					$Where .= $key."=";
					if ( preg_match("/^i_/i", $key) ) {
						$Where .= $val." AND ";
					} else {
						if ( get_magic_quotes_gpc()==0 ) {
							$val = addslashes($val);
						}
						$Where .= "'".$val."' AND ";
					}
				}
			}
		}
		$cnt = strlen($Where);
		$Where = substr($Where, 0, $cnt-5);
		$db->Query($SQL_query.$Where, $result);
		$row = $this->DB_fetch_assoc($result);

		return $row['i_mainid'];
	}

	function DB_Protect($db, $topic_table, $reply_table) {
		$SQL_query = "LOCK TABLES ".$topic_table." WRITE, ".$reply_table." WRITE";
		$db->Query($SQL_query, $result);
	}

	function DB_UnProtect($db) {
		$SQL_query = "UNLOCK TABLES";
		$db->Query($SQL_query, $result);
	}

	function DecodeEntities($dat="") {
		if ( is_array($dat) ) {
			foreach ( $dat as $key=>$val ) {
				$buff = $val;
				$buff = str_replace("&quot;", "\"", $buff);
				$buff = str_replace("&#039;", "'", $buff);
				$dat[$key] = $buff;
			}
		}
		return $dat;
	}

	function ShowTables($db, &$TableList) {
		$SQL_query = "select * from pg_tables where tableowner = '".DEF_DB_USER."'";
		$db->Query($SQL_query, $TableList);
	}

	function CreateCommonTable($db, $TableName) {
		$SQL_query = "";
		switch($TableName) {
			case DEF_UNIQUE_TABLE:
				$SQL_query = "create table ".DEF_UNIQUE_TABLE." (
					ID serial NOT NULL primary key,
					HName varchar(50) NOT NULL,
					PWD varchar(32) NOT NULL, GrantMode int, GrantEdit int,
					GrantFin int, GrantDel int, TagName varchar(20))";
				break;
			case DEF_ACCESS_TABLE:
				$SQL_query = "create table ".DEF_ACCESS_TABLE." (
					ID serial NOT NULL primary key,
					AccessKind int, AddressData varchar(64), Comment text)";
				break;
			case DEF_XWORD_TABLE:
				$SQL_query = "create table ".DEF_XWORD_TABLE." (
					ID serial NOT NULL primary key, WordData varchar(64))";
				break;
			case DEF_PROXY_TABLE:
				$SQL_query = "create table ".DEF_PROXY_TABLE." (
					ID serial NOT NULL primary key,	AddressData varchar(64))";
				break;
			default:
				$SQL_query = "create schema ".DEF_SCHEMA;
				$cnt = strlen($SQL_query);
				$SQL_query = substr($SQL_query, 0, $cnt-1);
		}
		$db->Query($SQL_query, $result);
	}

	function CreateBBSTable($db, $TableKind, $board) {
		$SQL_query = "";
		switch($TableKind) {
			case 0:
				$SQL_query = "create table ".DEF_PRE_TABLE.$board."_topic (
					i_MainID serial NOT NULL primary key,
					i_TopicDate int, i_ReplyDate int, Subject varchar(64),
					Name varchar(64), TagName varchar(20), i_Rank int,
					EMail varchar(64), URL varchar(64), ICQ varchar(20), IP varchar(64), PWD varchar(32),
					Comment text, Menu varchar(32),	Remote_Host varchar(64), i_Flag int,
					i_UID int, TripID varchar(32), i_Update int, UpName varchar(64))";
				break;
			case 1:
				$SQL_query = "create table ".DEF_PRE_TABLE.$board."_reply (
					i_SubID serial NOT NULL primary key,
					i_MainID int NOT NULL, i_ReplyDate int, Name varchar(64), TagName varchar(20), i_Rank int,
					EMail varchar(64), URL varchar(64), ICQ varchar(20),
					IP varchar(64), PWD varchar(32), Comment text, Remote_Host varchar(64),
					i_Flag int, i_UID int, TripID varchar(32), i_Update int, UpName varchar(64))";
		}
		$db->Query($SQL_query, $result);
	}

	function OffsetSQL($Start_Pos, $ViewCount) {
		$OffsetStr = "";
		$OffsetStr = " OFFSET ".$Start_Pos." LIMIT ".$ViewCount;
		return $OffsetStr;
	}

	function CreateOtherTable($db, $TableKind=0, $TableName) {
		$SQL_query = "";
		switch($TableKind) {
			case 0:
				$SQL_query = "create table ".$TableName." (
					i_ID serial NOT NULL primary key,
					HName varchar(50) NOT NULL, PWD varchar(32) NOT NULL, TagName varchar(20), i_ApplyMode int)";
		}
		$db->Query($SQL_query, $result);
	}

	function DropTable($db, $TableName) {
		$SQL_query = "drop table ".$TableName;
		$db->Query($SQL_query, $result);
	}
}
?>
